require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_INAT_H)) {
    eval 'sub _ASM_X86_INAT_H () {1;}' unless defined(&_ASM_X86_INAT_H);
    require 'asm/inat_types.ph';
    eval 'sub INAT_OPCODE_TABLE_SIZE () {256;}' unless defined(&INAT_OPCODE_TABLE_SIZE);
    eval 'sub INAT_GROUP_TABLE_SIZE () {8;}' unless defined(&INAT_GROUP_TABLE_SIZE);
    eval 'sub INAT_PFX_OPNDSZ () {1;}' unless defined(&INAT_PFX_OPNDSZ);
    eval 'sub INAT_PFX_REPE () {2;}' unless defined(&INAT_PFX_REPE);
    eval 'sub INAT_PFX_REPNE () {3;}' unless defined(&INAT_PFX_REPNE);
    eval 'sub INAT_PFX_LOCK () {4;}' unless defined(&INAT_PFX_LOCK);
    eval 'sub INAT_PFX_CS () {5;}' unless defined(&INAT_PFX_CS);
    eval 'sub INAT_PFX_DS () {6;}' unless defined(&INAT_PFX_DS);
    eval 'sub INAT_PFX_ES () {7;}' unless defined(&INAT_PFX_ES);
    eval 'sub INAT_PFX_FS () {8;}' unless defined(&INAT_PFX_FS);
    eval 'sub INAT_PFX_GS () {9;}' unless defined(&INAT_PFX_GS);
    eval 'sub INAT_PFX_SS () {10;}' unless defined(&INAT_PFX_SS);
    eval 'sub INAT_PFX_ADDRSZ () {11;}' unless defined(&INAT_PFX_ADDRSZ);
    eval 'sub INAT_PFX_REX () {12;}' unless defined(&INAT_PFX_REX);
    eval 'sub INAT_PFX_VEX2 () {13;}' unless defined(&INAT_PFX_VEX2);
    eval 'sub INAT_PFX_VEX3 () {14;}' unless defined(&INAT_PFX_VEX3);
    eval 'sub INAT_LSTPFX_MAX () {3;}' unless defined(&INAT_LSTPFX_MAX);
    eval 'sub INAT_LGCPFX_MAX () {11;}' unless defined(&INAT_LGCPFX_MAX);
    eval 'sub INAT_IMM_BYTE () {1;}' unless defined(&INAT_IMM_BYTE);
    eval 'sub INAT_IMM_WORD () {2;}' unless defined(&INAT_IMM_WORD);
    eval 'sub INAT_IMM_DWORD () {3;}' unless defined(&INAT_IMM_DWORD);
    eval 'sub INAT_IMM_QWORD () {4;}' unless defined(&INAT_IMM_QWORD);
    eval 'sub INAT_IMM_PTR () {5;}' unless defined(&INAT_IMM_PTR);
    eval 'sub INAT_IMM_VWORD32 () {6;}' unless defined(&INAT_IMM_VWORD32);
    eval 'sub INAT_IMM_VWORD () {7;}' unless defined(&INAT_IMM_VWORD);
    eval 'sub INAT_PFX_OFFS () {0;}' unless defined(&INAT_PFX_OFFS);
    eval 'sub INAT_PFX_BITS () {4;}' unless defined(&INAT_PFX_BITS);
    eval 'sub INAT_PFX_MAX () {((1<<  &INAT_PFX_BITS) - 1);}' unless defined(&INAT_PFX_MAX);
    eval 'sub INAT_PFX_MASK () {( &INAT_PFX_MAX <<  &INAT_PFX_OFFS);}' unless defined(&INAT_PFX_MASK);
    eval 'sub INAT_ESC_OFFS () {( &INAT_PFX_OFFS +  &INAT_PFX_BITS);}' unless defined(&INAT_ESC_OFFS);
    eval 'sub INAT_ESC_BITS () {2;}' unless defined(&INAT_ESC_BITS);
    eval 'sub INAT_ESC_MAX () {((1<<  &INAT_ESC_BITS) - 1);}' unless defined(&INAT_ESC_MAX);
    eval 'sub INAT_ESC_MASK () {( &INAT_ESC_MAX <<  &INAT_ESC_OFFS);}' unless defined(&INAT_ESC_MASK);
    eval 'sub INAT_GRP_OFFS () {( &INAT_ESC_OFFS +  &INAT_ESC_BITS);}' unless defined(&INAT_GRP_OFFS);
    eval 'sub INAT_GRP_BITS () {5;}' unless defined(&INAT_GRP_BITS);
    eval 'sub INAT_GRP_MAX () {((1<<  &INAT_GRP_BITS) - 1);}' unless defined(&INAT_GRP_MAX);
    eval 'sub INAT_GRP_MASK () {( &INAT_GRP_MAX <<  &INAT_GRP_OFFS);}' unless defined(&INAT_GRP_MASK);
    eval 'sub INAT_IMM_OFFS () {( &INAT_GRP_OFFS +  &INAT_GRP_BITS);}' unless defined(&INAT_IMM_OFFS);
    eval 'sub INAT_IMM_BITS () {3;}' unless defined(&INAT_IMM_BITS);
    eval 'sub INAT_IMM_MASK () {(((1<<  &INAT_IMM_BITS) - 1) <<  &INAT_IMM_OFFS);}' unless defined(&INAT_IMM_MASK);
    eval 'sub INAT_FLAG_OFFS () {( &INAT_IMM_OFFS +  &INAT_IMM_BITS);}' unless defined(&INAT_FLAG_OFFS);
    eval 'sub INAT_MODRM () {(1<< ( &INAT_FLAG_OFFS));}' unless defined(&INAT_MODRM);
    eval 'sub INAT_FORCE64 () {(1<< ( &INAT_FLAG_OFFS + 1));}' unless defined(&INAT_FORCE64);
    eval 'sub INAT_SCNDIMM () {(1<< ( &INAT_FLAG_OFFS + 2));}' unless defined(&INAT_SCNDIMM);
    eval 'sub INAT_MOFFSET () {(1<< ( &INAT_FLAG_OFFS + 3));}' unless defined(&INAT_MOFFSET);
    eval 'sub INAT_VARIANT () {(1<< ( &INAT_FLAG_OFFS + 4));}' unless defined(&INAT_VARIANT);
    eval 'sub INAT_VEXOK () {(1<< ( &INAT_FLAG_OFFS + 5));}' unless defined(&INAT_VEXOK);
    eval 'sub INAT_VEXONLY () {(1<< ( &INAT_FLAG_OFFS + 6));}' unless defined(&INAT_VEXONLY);
    eval 'sub INAT_MAKE_PREFIX {
        my($pfx) = @_;
	    eval q(($pfx <<  &INAT_PFX_OFFS));
    }' unless defined(&INAT_MAKE_PREFIX);
    eval 'sub INAT_MAKE_ESCAPE {
        my($esc) = @_;
	    eval q(($esc <<  &INAT_ESC_OFFS));
    }' unless defined(&INAT_MAKE_ESCAPE);
    eval 'sub INAT_MAKE_GROUP {
        my($grp) = @_;
	    eval q((($grp <<  &INAT_GRP_OFFS) |  &INAT_MODRM));
    }' unless defined(&INAT_MAKE_GROUP);
    eval 'sub INAT_MAKE_IMM {
        my($imm) = @_;
	    eval q(($imm <<  &INAT_IMM_OFFS));
    }' unless defined(&INAT_MAKE_IMM);
    eval 'sub inat_is_address_size_prefix {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_PFX_MASK) ==  &INAT_PFX_ADDRSZ; });
    }' unless defined(&inat_is_address_size_prefix);
    eval 'sub inat_is_operand_size_prefix {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_PFX_MASK) ==  &INAT_PFX_OPNDSZ; });
    }' unless defined(&inat_is_operand_size_prefix);
    eval 'sub inat_is_rex_prefix {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_PFX_MASK) ==  &INAT_PFX_REX; });
    }' unless defined(&inat_is_rex_prefix);
    eval 'sub inat_last_prefix_id {
        my($attr) = @_;
	    eval q({  &if (($attr &  &INAT_PFX_MASK) >  &INAT_LSTPFX_MAX) 0;  &else $attr &  &INAT_PFX_MASK; });
    }' unless defined(&inat_last_prefix_id);
    eval 'sub inat_is_vex_prefix {
        my($attr) = @_;
	    eval q({ $attr &=  &INAT_PFX_MASK; $attr ==  &INAT_PFX_VEX2 || $attr ==  &INAT_PFX_VEX3; });
    }' unless defined(&inat_is_vex_prefix);
    eval 'sub inat_is_vex3_prefix {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_PFX_MASK) ==  &INAT_PFX_VEX3; });
    }' unless defined(&inat_is_vex3_prefix);
    eval 'sub inat_is_escape {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_ESC_MASK; });
    }' unless defined(&inat_is_escape);
    eval 'sub inat_escape_id {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_ESC_MASK) >>  &INAT_ESC_OFFS; });
    }' unless defined(&inat_escape_id);
    eval 'sub inat_is_group {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_GRP_MASK; });
    }' unless defined(&inat_is_group);
    eval 'sub inat_group_id {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_GRP_MASK) >>  &INAT_GRP_OFFS; });
    }' unless defined(&inat_group_id);
    eval 'sub inat_group_common_attribute {
        my($attr) = @_;
	    eval q({ $attr & ~ &INAT_GRP_MASK; });
    }' unless defined(&inat_group_common_attribute);
    eval 'sub inat_has_immediate {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_IMM_MASK; });
    }' unless defined(&inat_has_immediate);
    eval 'sub inat_immediate_size {
        my($attr) = @_;
	    eval q({ ($attr &  &INAT_IMM_MASK) >>  &INAT_IMM_OFFS; });
    }' unless defined(&inat_immediate_size);
    eval 'sub inat_has_modrm {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_MODRM; });
    }' unless defined(&inat_has_modrm);
    eval 'sub inat_is_force64 {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_FORCE64; });
    }' unless defined(&inat_is_force64);
    eval 'sub inat_has_second_immediate {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_SCNDIMM; });
    }' unless defined(&inat_has_second_immediate);
    eval 'sub inat_has_moffset {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_MOFFSET; });
    }' unless defined(&inat_has_moffset);
    eval 'sub inat_has_variant {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_VARIANT; });
    }' unless defined(&inat_has_variant);
    eval 'sub inat_accept_vex {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_VEXOK; });
    }' unless defined(&inat_accept_vex);
    eval 'sub inat_must_vex {
        my($attr) = @_;
	    eval q({ $attr &  &INAT_VEXONLY; });
    }' unless defined(&inat_must_vex);
}
1;
